'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAddonsUpdate = require('react-addons-update');

var _reactAddonsUpdate2 = _interopRequireDefault(_reactAddonsUpdate);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// for filtering text
var doFilterTimeoutIt;

var ODataTable = function (_React$Component) {
    _inherits(ODataTable, _React$Component);

    function ODataTable(props) {
        _classCallCheck(this, ODataTable);

        var _this = _possibleConstructorReturn(this, (ODataTable.__proto__ || Object.getPrototypeOf(ODataTable)).call(this, props));

        _this.state = {
            Page: 0,
            limit: 10,
            dataCount: 0,
            orderByColumn: _this.props.columnsAndKeys.filter(function (r) {
                return r.orderBy;
            }).map(function (r) {
                return r.serverKey;
            })[0] || null,
            orderByType: 'asc', // asc | desc
            dataList: [],
            columnsAndKeys: _this.props.columnsAndKeys.map(function (r) {
                r.filterTxt = '';
                return r;
            }),
            //TODO
            loadingDataList: false
        };

        _this.renderDataList = _this.renderDataList.bind(_this);
        _this.renderPagination = _this.renderPagination.bind(_this);
        _this.renderLoading = _this.renderLoading.bind(_this);
        _this.onColumnFilterChange = _this.onColumnFilterChange.bind(_this);
        _this.goPrevPage = _this.goPrevPage.bind(_this);
        _this.goNextPage = _this.goNextPage.bind(_this);
        _this.setDataLoading = _this.setDataLoading.bind(_this);
        _this.isDataLoading = _this.isDataLoading.bind(_this);
        _this.httpRequest = _this.httpRequest.bind(_this);
        _this.onOrderColumnClick = _this.onOrderColumnClick.bind(_this);
        _this.renderUpDownIcon = _this.renderUpDownIcon.bind(_this);
        return _this;
    }

    _createClass(ODataTable, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.getData(this.state.Page);
        }
    }, {
        key: 'setDataLoading',
        value: function setDataLoading(loadingDataList) {
            this.setState({
                loadingDataList: loadingDataList
            });
        }
    }, {
        key: 'isDataLoading',
        value: function isDataLoading() {
            return this.state.loadingDataList;
        }
    }, {
        key: 'goPrevPage',
        value: function goPrevPage() {
            var _this2 = this;

            if (this.state.Page == 0) {
                return;
            }

            var newPage = this.state.Page - 1;

            this.setState({
                Page: newPage
            }, function () {
                return _this2.getData(newPage);
            });
        }
    }, {
        key: 'goNextPage',
        value: function goNextPage() {
            var _this3 = this;

            var newPage = this.state.Page + 1;

            this.setState({
                Page: newPage
            }, function () {
                return _this3.getData(newPage);
            });
        }
    }, {
        key: 'getData',
        value: function getData(Page) {

            if (this.isDataLoading()) {
                return;
            }

            var self = this;
            var limit = self.state.limit;
            var columnsAndKeys = this.state.columnsAndKeys;
            var filterStr = columnsAndKeys.filter(function (r) {
                return r.type == 'string';
            }).filter(function (r) {
                return r.filterTxt != '';
            }).map(function (r) {
                return "contains(" + r.serverKey + ", '" + r.filterTxt + "')";
            }).join(" and ");

            var eqKeySearch = columnsAndKeys.filter(function (r) {
                return r.key == true;
            }).filter(function (r) {
                return r.filterTxt != '';
            }).map(function (r) {
                return r.serverKey + ' eq ' + r.filterTxt;
            }).join('');

            console.log("eqKeySearch", eqKeySearch);

            if (filterStr) {

                if (eqKeySearch) {
                    filterStr += " and " + eqKeySearch;
                }
            } else {
                filterStr = eqKeySearch;
            }

            var url = this.props.odataUrl + "?" + "$select=" + this._getSelectColumns().join(',') + "&$skip=" + Page * limit + "&$top=" + limit + "&$count=true" + "&$orderby=" + this.state.orderByColumn + " " + this.state.orderByType + "&$format=json";

            if (filterStr) {
                url += "&$filter=" + filterStr;
            }

            this.httpRequest(url);
        }
    }, {
        key: 'httpRequest',
        value: function httpRequest(url) {

            var self = this;
            self.setDataLoading(true);

            _axios2.default.get(url).then(function (r) {

                self.setState({
                    dataList: r.data.value,
                    dataCount: r.data["@odata.count"]
                });

                self.setDataLoading(false);
            });
        }
    }, {
        key: 'getTableColumnAndKeys',
        value: function getTableColumnAndKeys() {}
    }, {
        key: '_getSelectColumns',
        value: function _getSelectColumns() {
            return this.state.columnsAndKeys.filter(function (r) {
                return r.serverKey != null;
            }).map(function (r) {
                return r.serverKey;
            });
        }
    }, {
        key: 'onOrderColumnClick',
        value: function onOrderColumnClick(serverKey) {

            var self = this;
            var oldOrderByColumn = this.state.orderByColumn;
            var orderByType = this.state.orderByType;
            var newOrderByColumn = serverKey;

            if (oldOrderByColumn == newOrderByColumn) {

                if (orderByType == 'asc') {
                    orderByType = 'desc';
                } else {
                    orderByType = 'asc';
                }
            }

            this.setState({
                orderByColumn: newOrderByColumn,
                orderByType: orderByType
            }, function () {
                self.getData(0);
            });
        }
    }, {
        key: 'renderUpDownIcon',
        value: function renderUpDownIcon(serverKey) {

            var orderByColumn = this.state.orderByColumn;
            var orderByType = this.state.orderByType;
            var icon;

            if (serverKey == orderByColumn) {

                if (orderByType == 'asc') {
                    icon = '↑';
                } else {
                    icon = '↓';
                }
            }

            return icon;
        }
    }, {
        key: 'renderDataList',
        value: function renderDataList() {

            var self = this;
            var columnsAndKeys = this.state.columnsAndKeys;
            var dataList = this.state.dataList;
            var tableClass = this.props.tableClass;
            var theadClass = this.props.theadClass;
            var tbodyClass = this.props.tbodyClass;
            var trClass = this.props.trClass;
            var thClass = this.props.thClass;
            var tdClass = this.props.tdClass;

            return _react2.default.createElement(
                'table',
                { className: 'table table-hover table-striped table-bordered' },
                _react2.default.createElement(
                    'thead',
                    null,
                    _react2.default.createElement(
                        'tr',
                        null,
                        columnsAndKeys.map(function (row, i) {
                            return _react2.default.createElement(
                                'th',
                                { key: i },
                                _react2.default.createElement(
                                    'span',
                                    {
                                        style: { cursor: 'pointer' },
                                        onClick: function onClick(e) {
                                            return self.onOrderColumnClick(row.serverKey);
                                        }
                                    },
                                    row.visualName,
                                    '\xA0',
                                    self.renderUpDownIcon(row.serverKey)
                                )
                            );
                        })
                    )
                ),
                _react2.default.createElement(
                    'tbody',
                    null,
                    _react2.default.createElement(
                        'tr',
                        null,


                        /* render sort input rows */
                        columnsAndKeys.map(function (row, i) {
                            return _react2.default.createElement(
                                'td',
                                { key: i },
                                row.type == 'options' ? null : _react2.default.createElement('input', {
                                    placeholder: "Filter by: " + row.visualName,
                                    value: columnsAndKeys[i].filterTxt,
                                    onChange: function onChange(e) {
                                        return self.onColumnFilterChange(i, e);
                                    }
                                })
                            );
                        })
                    ),

                    /* render table rows */
                    dataList.map(function (dataRow, i) {
                        return _react2.default.createElement(
                            'tr',
                            { key: i },
                            columnsAndKeys.map(function (row, i) {
                                return _react2.default.createElement(
                                    'td',
                                    { key: i },
                                    row.type == 'options' ? self.renderOptions(dataRow.Id) : dataRow[row.serverKey]
                                );
                            })
                        );
                    })
                )
            );
        }
    }, {
        key: 'renderPagination',
        value: function renderPagination() {

            var Page = this.state.Page;
            var prevDisabled = Page == 0;

            return _react2.default.createElement(
                'nav',
                null,
                _react2.default.createElement(
                    'ul',
                    { className: 'pagination' },
                    _react2.default.createElement(
                        'li',
                        { className: "page-item " + (prevDisabled && 'disabled') },
                        _react2.default.createElement(
                            'span',
                            { className: 'page-link', onClick: this.goPrevPage },
                            'Previous'
                        )
                    ),
                    _react2.default.createElement(
                        'li',
                        { className: 'page-item' },
                        _react2.default.createElement(
                            'a',
                            { className: 'page-link', onClick: this.goNextPage },
                            'Next'
                        ),
                        ' '
                    ),
                    this.isDataLoading() && _react2.default.createElement(
                        'li',
                        { className: 'page-item' },
                        _react2.default.createElement(
                            'a',
                            { className: 'page-link' },
                            this.renderLoading()
                        )
                    )
                )
            );
        }
    }, {
        key: 'onColumnFilterChange',
        value: function onColumnFilterChange(i, e) {

            var self = this;
            var oldColumnsAndKeys = this.state.columnsAndKeys;
            var newColumnsAndKeys = (0, _reactAddonsUpdate2.default)(oldColumnsAndKeys, _defineProperty({}, i, {
                filterTxt: {
                    $set: e.target.value
                }
            }));

            this.setState({ columnsAndKeys: newColumnsAndKeys }, function () {

                if (doFilterTimeoutIt) {
                    clearTimeout(doFilterTimeoutIt);
                }

                doFilterTimeoutIt = setTimeout(function () {
                    self.getData(0);
                }, 350);
            });
        }
    }, {
        key: 'renderLoading',
        value: function renderLoading() {

            if (this.isDataLoading() == false) {
                return null;
            }

            return _react2.default.createElement(
                'div',
                null,
                'Loading'
            );
        }
    }, {
        key: 'render',
        value: function render() {

            var paginationLocation = this.props.paginationLocation;

            return _react2.default.createElement(
                'div',
                null,
                paginationLocation == 'top' && this.renderPagination(),
                this.renderDataList(),
                paginationLocation == 'bottom' && this.renderPagination()
            );
        }
    }]);

    return ODataTable;
}(_react2.default.Component);

ODataTable.propTypes = {
    columnsAndKeys: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired,
    odataUrl: _propTypes2.default.string.isRequired,
    paginationLocation: _propTypes2.default.oneOf(['top', 'bottom']).isRequired
};

exports.default = ODataTable;